<?php
	/*******************************************************************************
     **  File          :  opmlitems.php                                            **
     **  Author        :  G.Ramkumar                                               **
     **  Description   :  Fetching The channel items Information from OPML Url     **
  	 **  Date          :  10/04/2006                                               **
     **  Last Modified :  12/04/2006                                               **
     **  PHP Version   :  5.0.3                                                    **
     **                                                                            **
     *******************************************************************************/
set_time_limit(0);
include('../db/dbconnect.php');

// Including Variables .....

$tag = "";
$title=array();
$description=array();
$link=array();
$pubdate=array();
$language=array();
$copyright="";
$lastbuild=array();
$imageurl=array();
$webmaster="";
$author=array();
$managing_editor="";
$generator="";
$docs="";
$cloud="";
$ttl="";
$rating=array();
$textinput="";
$skiphours="";
$skipdays="";

function startElement($parser, $tagname, $attrs)
{
	global $tag;
	global $title, $description,$link,$pubdate,$language,$copyright,$lastbuild,$imageurl,$webmaster,$author,$managing_editor,$generator,$docs,$cloud,$ttl,$rating,$textinput,$skiphours,$skipdays;

	$tag = $tagname;
}

function endElement($parser, $tagname)
{
	global $tag ;
	global $title, $description,$link,$pubdate,$language,$copyright,$lastbuild,$imageurl,$webmaster,$author,$managing_editor,$generator,$docs,$cloud,$ttl,$rating,$textinput,$skiphours,$skipdays;

	$tag="";
}

function characterData($parser, $data)
{
	global $tag;
	global $title, $description,$link,$pubdate,$language,$copyright,$lastbuild,$imageurl,$webmaster,$author,$managing_editor,$generator,$docs,$cloud,$ttl,$rating,$textinput,$skiphours,$skipdays;

    $data=trim($data);

  switch ($tag)
  {
		case "TITLE":
			$title[] = str_replace("'","||",$data);
			break;
	    case "DESCRIPTION":
			$description[] = $data;
			break;
		case "LINK":
			$link[] = $data;
			break;
		case "PUBDATE":
			$pubdate[] = $data;
			break;
		case "DC:DATE":
			$pubdate[] =$data;
		    break;
		case "LANGUAGE":
            $language[] = $data;
            break;
        case "LASTBUILDDATE":
            $lastbuild[] = $data;
            break;
        case "COPYRIGHT":
            $copyright .= $data;
            break;
         case "URL":
            $imageurl[] = $data;
            break;
         case "WEBMASTER":
            $webmaster .= $data;
            break;
         case "AUTHOR":
            $author[] = $data;
            break;
         case "MANAGINGEDITOR":
            $managing_editor .=$data;
            break;
         case "GENERATOR":
            $generator .=$data;
            break;
         case "DOCS":
            $docs .=$data;
            break;
         case "CLOUD":
            $cloud .=$data;
            break;
         case "TTL":
            $ttl .=$data;
            break;
         case "RATING":
            $rating[] =$data;
            break;
         case "TEXTINPUT":
            $textinput .=$data;
            break;
         case "HOUR":
            $skiphours .=($skiphours? ',':'').$data;
            break;
		 case "SKIPDAYS":
            $skipdays .=$data;
            break;

  }

}
//Date Format Conversion dd/mm/yyyy
include('date.php');

// Getting OPML  Files....
 $sel_qry="select channel_id,channel_url,channel_lastdate,channel_language from rsschannel where  channel_status='Y' and channel_url ~*'.*(opml)'";
 $sel_qry_res=$pg_sql->query_pass($sel_qry,"4");

 for($o=0;$o<count($sel_qry_res);$o++)
 {
	 $url=$sel_qry_res[$o]['channel_url'];
	 $chid=$sel_qry_res[$o]['channel_id'];
	 $chlastdate=$sel_qry_res[$o]['channel_lastdate'];
	 $chlanguage= $sel_qry_res[$o]['channel_language'];

// Getting Category From OPML channels

	 $sel_category="select * from rsschannel_category where rss_channel_id=$chid";
     $sel_cat_res=$pg_sql->query_pass($sel_category,"4");
     $cat_cnt=count($sel_cat_res);
     for($z=0;$z<$cat_cnt;$z++)
     {
      if($sel_cat_res[$z]['category_id']!="")
      {
        $category_id[] =$sel_cat_res[$z]['category_id'];

      }
      if($sel_cat_res[$z]['subcategory_id']!="")
	  {
	     $subcategory_id[] =$sel_cat_res[$z]['subcategory_id'];
	  }
    }
 
// Getting XML url and Test from OPML File

	 $file=file_get_contents($url);
	 $htmlcontent=htmlentities($file);
	 $outline =explode("&lt;outline",$htmlcontent);

	for($i=1;$i<count($outline);$i++)
	{
	  if(strstr($outline[$i],"xmlUrl"))
	  {
		preg_match("/(text=\&quot;)(.*?)(\&quot;)/i",$outline[$i],$mat_text);
			$opml_title[]=$mat_text[2];
		preg_match("/(xmlUrl=\&quot;)(.*?)(\&quot;)/i",$outline[$i],$mat_url);
			$opml_url[]=$mat_url[2];
	  }
	}
    	
	for($n=0;$n<count($opml_title);$n++)
	{
	  $exists_ch="select channel_url,channel_language from rsschannel where channel_url='$opml_url[$n]'";
	  $exists_ch_res=$pg_sql->query_pass($exists_ch,"4"); 
                                  
	  if(count($exists_ch_res)==0){
		 $rssfile=$opml_url[$n];
	     $con=@file_get_contents($rssfile);
	    if((strstr($con,"<rss")|| strstr($con,"<rdf") || strstr($con,"<feed")) && !strstr($con,"<html")){
			 $xml_parser = xml_parser_create();
			 xml_set_element_handler($xml_parser, "startElement", "endElement");
			 xml_set_character_data_handler($xml_parser, "characterData");
			 $fp = fopen($rssfile,"r") or die("Error reading RSS data.");
			 while ($data = fread($fp, 4096))
				   xml_parse($xml_parser, $data, feof($fp))
				   or die(sprintf("XML error: %s at line %d",
				   xml_error_string(xml_get_error_code($xml_parser)),
				   xml_get_current_line_number($xml_parser)));
			  fclose($fp);
			  xml_parser_free($xml_parser);
		  
          $channel_shortname=str_replace("'",'',$opml_title[$n]);
		  $channel_title=htmlspecialchars(trim(str_replace("'",'',$title[0])));
		  $channel_desc=htmlspecialchars(trim(str_replace("'",'',$description[0])));
		  if(strlen($channel_desc)<5)
			 $channel_desc=$channel_shortname;
		  else
			 $channel_desc=$channel_desc;
		  $channel_url=trim($link[0]);
		  $channel_pubdate=trim($pubdate[0]);
		  $channel_language=$chlanguage;
		  $channel_image=$imageurl[0];
		  $channel_lastdate=date("Y-n-j");
		  $channel_copyright=$copyright;
		  $channel_webmaster=$webmaster;
		  $channel_author=$author[0];
		  $channel_managing=$managing_editor;
		  $channel_generator=$generator;
		  $channel_docs=$docs;
		  $channel_cloud=$cloud;
		  $channel_ttl=$ttl;
		  $channel_rating=$rating[0];
		  $channel_textinput=$textinput;
		  $channel_skiphours=$skiphours;
		  $channel_skipdays=$skipdays;

 		  $pubdate=$pubdate[0];		   
  		  if(strstr($pubdate,",")){
			$date=explode(" ",$pubdate);
		  if(strstr($date[1],"-")){
			$datehyp=explode("-",$date[1]);

		  if(substr($datehyp[0],0,1)==0)
		 	 $datehyp[0]=str_replace("0","",$datehyp[0]);
		  else
			 $datehyp[0]=$datehyp[0];
 			 $newdate= $datehyp[0]."/".get_month($datehyp[1])."/".$datehyp[2];
		  }else{
			 if(empty($date[1]))
			 {
			   if(substr($date[2],0,1)==0)
				$date[2]=str_replace("0","",$date[2]);
			   else
				$date[2]=$date[2];

				$newdate=$date[2]."/".get_month($date[3])."/".$date[4];
			 }
			 else{
				 if(substr($date[1],0,1)==0)
				  $date[1]=str_replace("0","",$date[1]);
				 else
				  $date[1]=$date[1];
		  	      $newdate=$date[1]."/".get_month($date[2])."/".$date[3];
			 }
		  }
		}elseif(!strstr($pubdate,",") && strstr($pubdate,"-")){
		   $date=explode("-",$pubdate);
		   $hypdat=substr($date[2],0,2);
			   if(substr($hypdat,0,1)==0)
				 $hypdat=str_replace("0","",$hypdat);
			   else
				 $hypdat=$hypdat;

			if(substr($date[1],0,1)==0)
			  $date[1]=str_replace("0","",$date[1]);
			 else
			  $date[1]=$date[1];

		   $newdate=$hypdat."/".$date[1]."/".$date[0];
		}else{
		  $newdate=$pubdate;
		}
		 $channel_pubdate=$newdate;

      
	 //****** Inserting Channel Details in to table Rsschannel*******

  $Rss_qry="Insert into rsschannel (channel_title,channel_shortname,channel_description,channel_url,channel_image,channel_author,channel_copyright,channel_webmaster,channel_language,channel_pubdate,channel_lastdate,channel_status,channel_managing_editor,channel_generator,channel_docs,channel_cloud,channel_rating,channel_text_input,channel_skiphours,channel_skipdays,channel_ttl) values ('$channel_title','$channel_shortname','$channel_desc','$opml_url[$n]','$image','$channel_author','$channel_copyright','$channel_webmaster','$channel_language','$channel_pubdate','$channel_lastdate','Y','$channel_managing','$channel_generator','$channel_docs','$channel_cloud','$channel_rating','$channel_textinput','$channel_skiphours','$channel_skipdays','$channel_ttl')";

  $Rss_res=$pg_sql->query_pass($Rss_qry,"4");

 // Get Last id from Table
		$get_max="select max(channel_id) as channel_id from rsschannel";
		$get_maxres=$pg_sql->query_pass($get_max,"4");
		$new_id=$get_maxres[0]['channel_id'];

		for($c=0;$c<count($category_id);$c++)
		{
			$cat_id=$category_id[$c];
			if($cat_id !=""){
					$Rsscat_chan="insert into rsschannel_category (rss_channel_id,category_id) values ('$new_id','$cat_id')";
		   	        $Rsscat_res=$pg_sql->query_pass($Rsscat_chan,"4");
			  }
		}

		for($s=0;$s<count($subcategory_id);$s++)
		{
			$subcat_id=$subcategory_id[$s];
			if($subcat_id!=""){
				  $Rsssubcat_chan="insert into rsschannel_category (rss_channel_id,subcategory_id) values ('$new_id','$subcat_id')";
			      $Rsssubcat_res=$pg_sql->query_pass($Rsssubcat_chan,"4");
			}
		}

   $new_id='';
   $cat_id='';
   $subcat_id='';

 } // If count Closing ......
     $new_id='';
	 $channel_shortname='';
     $channel_title='';
	 $channel_desc='';
	 $channel_url='';
	 $channel_pubdate='';
	 $channel_language='';
	 $channel_image='';
	 $channel_lastdate='';
	 $channel_copyright='';
	 $channel_webmaster='';
	 $channel_author='';
	 $channel_managing='';
	 $channel_generator='';
	 $channel_docs='';
	 $channel_cloud='';
	 $channel_ttl='';
	 $channel_rating='';
	 $channel_textinput='';
	 $channel_skiphours='';
	 $channel_skipdays='';
	 $title ='';
	 $description ='';
	 $link='';
	 $pubdate='';
     $copyright='';
     $webmaster='';
     $author='';
  	 $managing_editor='';
     $generator='';
     $docs='';
	 $cloud='';
     $ttl='';
	 $rating='';
     $textinput='';
     $skiphours='';
     $skipdays='';
	 $cat_id='';
 	 $subcat_id='';
	  }  //If condition url Exists or not..
	}  //For OPML TITLE cnt closing
	$category_id='';
	$subcategory_id='';
	$url='';
    $chid='';
    $chlastdate='';
    $chlanguage='';
	$opml_title='';
	$opml_url='';
} //$o Loop TERMIANTES

?>